﻿; Test für COM - TurboCAD (TC)
; AutoIt Version: 3.0
; Language:       Deutsch
; Platform:       Win9x/NT/EindowsXP
; Author:         Peter Salomon
;
; Script Function:
;  Demonstriert, 
; (1)	wie die Eingabe von einer InputBox in die TC-Zeichnung kommt
; (2)	wie ein einfaches Rechteck aus den Daten seiner Eck-Koordinaten generiert wird
; (3)	ein Geschwindigkeitstest: es können bis ca. 10.000 einfache Graphic-Objekte gezeichnet werden

Global $TCapp, $dwg, $dwgLoad, $activeDwg, $Text, $newText, $input1, $input2, $input3	; alle verwendeten Variablen sind vorher zu deklarieren

;#comments-start																			; hiermit kann nachfolgender Code von der Compilierung ausgenommen werden - bis #comments-end
$TCapp = ObjCreate("TurboCAD.Application") 												; Instanziert ein TC-Objekt, falls TC schon läuft, wird keine neue Instanz erzeugt, 
																						; wohl aber ein neues Zeichnungsblatt
; WinWaitActive("[CLASS:Notepad]",'',5)													; (nur Vorlage)
WinWaitActive("TurboCAD",'',5)															; solange warten bis TC geladen ist

If $TCapp = -1 Then
	MsgBox ( 0, "Fehler", "Die COM konnte nicht hergestellt werden")
	Exit
Else
	MsgBox(0, "Application-Name", $TCapp.name & "...." & @CRLF & "ist jetzt geladen und kann verwendet werden")	
																						; TC ist jetzt geladen - im Hintergrund unsichtbar!
EndIf

$TCapp.Visible = 1																		; das TC-Fenster sichtbar machen, ist aber immer noch runtergeklappt in der Statusleiste
;$dwg = $TCapp.GetOpenFilename() 														; Zeichnung wird ausgewählt (Variante)

;Msgbox (0, "Zeichnungsname", $dwg)														; nur zum Test
$TCapp.Drawings.Add 																	; ein leeres Zeichnungsblatt (Vorlagen-Zeichnung) wird geladen (ist jetzt "ActiveDrawing")
																						; war TC schon mit einem Zeichnungsblatt geladen, wird ein weiteres hinzugefügt.
;$dwgLoad = $TCapp.Drawings.Open($dwg)													; Damit könnte eine vorhandene Zeichnungs-Datei "$dwg" geöffnet werden

$activeDwg = $TCapp.ActiveDrawing														; eine Referenz zur aktiven, auf dem Bildschirm dargestellten Zeichnung, d.h das neue leere Zeichnungsblatt
Msgbox (0, "Zeichnungsname", $activeDwg.Name)											; nur zum Test (kann auskommentiert werden)
;
; (1)
$Text = InputBox("AutoIt Beispiel Text", "Bitte einen beliebigen Text schreiben")		; bringt eine InputBox auf dn Bildschirm zur Eingabe
$newText = $activeDwg.Graphics.addText ($Text, 100, 100, 0, 20)							; der Text wird jetzt auf der aktiven Zeichnung 
																						; an den Koordinaten x=100, y=100, z=0 mit der Höhe 20 abgebildet
#comments-end
;
; (2)
#include <GUIConstantsEx.au3>															; sonst geht die GUI_Event-Funktion nicht
_Main()																					; Deklaration der _Main-Funktion, ohne diese Deklaration keine GUI-Darstellung!
;
Func _Main()
Local $msg, $Form1, $Label1, $Label2, $Button1, $Button2								; Lokale Variablen müssen hier deklariert werden, weil innerhalb einer abgeschlossenen Funktion
;
Opt("GUIOnEventMode", 1)																; Parameter = 1, sonst keine CtrlEvent-Bearbeitung
;
$Form1 = GUICreate("AutoIt Test", 200, 220, 200, 100)									; erzeugt eine GUI, mit Namen und Größen-Parameter: Breite, Höhe, von links, von oben
GUISetOnEvent($GUI_EVENT_CLOSE, "SpecialEvents")										; Spezial-Events zur GUI-Handhabung
$Label1 = GUICtrlCreateLabel("Rechteck-Breite", 15, 15, 80, 30)							; erstellt ein Label-Control, Parameter: von links, von oben, Breite, Höhe
$input1 = GUICtrlCreateInput ("", 100, 15, 50, 20)										; erstellt ein Input-Control auf der GUI, Parameter: von links, von oben, Breite, Höhe
$Label2 = GUICtrlCreateLabel("Rechteck-Höhe", 15, 55, 80, 30)
$input2 = GUICtrlCreateInput ("", 100, 55, 50, 20)
$Button1 = GUICtrlCreateButton("OK", 120, 90, 60, 25)									; erstellt ein Button (Schaltfläche), Parameter: von links, von oben, Breite, Höhe
GUICtrlSetOnEvent($Button1, "Button1_OK")
;
; (3)
$Label3 = GUICtrlCreateLabel("Objektanzahl", 15, 150, 80, 30)
$input3 = GUICtrlCreateInput ("", 100, 150, 50, 20)
$Button2 = GUICtrlCreateButton("Start", 120, 180, 60, 25)								; erstellt ein Button (Schaltfläche), Parameter: von links, von oben, Breite, Höhe
GUICtrlSetOnEvent($Button2, "Button2_Start")
;
GUISetState(@SW_SHOW)																	; damit wird die GUI angezeigt
;
While 1																					; die Windows-"Hauptprogramm"-Schleife
	Sleep(10)
WEnd
;
EndFunc
;
; ---------------------------------------------------------------------------------
;
Func SpecialEvents()																	; hier sind die Special-Events der GUI: 
																						; Fenster Schliessen, Minimieren, Maximieren, keine Grössenveränderung (mit Mouse-Bedienung)!
	;MsgBox (0, "ID", @GUI_CtrlId)														; nur zum Test
	Select
        Case @GUI_CtrlId = $GUI_EVENT_CLOSE
            ;MsgBox(0, "Schliessen gedrückt", "ID=" & @GUI_CtrlId & " WinHandle=" & @GUI_WinHandle)
            $TCapp.Quit																	; Beenden der aktuellen TC-Sitzung, es wird nach dem Speichern der aktuellen Zeichnung gefragt
			Exit

        Case @GUI_CtrlId = $GUI_EVENT_MINIMIZE											; (wird hier nicht verwendet)
            ;MsgBox(0, "Fenster minimiert", "ID=" & @GUI_CtrlId & " WinHandle=" & @GUI_WinHandle)

        Case @GUI_CtrlId = $GUI_EVENT_RESTORE											; (wird hier nicht verwendet)
            ;MsgBox(0, "Fenster wiederhergestellt", "ID=" & @GUI_CtrlId & " WinHandle=" & @GUI_WinHandle)
		;
    EndSelect
;
EndFunc
;
;---------------------------------------------------------------------------------
;
Func Button1_OK()																		; erst beim Betätigen des Buttons wird das Rechteck gezeichnet
																						; mit jedem Drücken des Buttons wird eine neues Rechteck auf der gleichen Zeichnung generiert!
	Local $newRect, $inp1, $inp2 
	;MsgBox (0, "Button1", $Button1)													; nur zu Testzwecken, 
																						; es wird der Rückgabewert der Erstellungsfunktion von Button1 ausgegeben
	$inp1 = GUICtrlRead($input1)														; Auslesen der Datenwerte (in mm, oder je nach TC-Grundeinstellung)
	$inp2 = GUICtrlRead($input2)
	$newRect = $activeDwg.Graphics.AddLineRectangle(100, 100, 0, 100 + $inp1, 100 + $inp2, 0)				
																						; hier wird das neue Rechteck gezeichnet mit den Koordinaten	X0, Y0, Z0 (linke untere Ecke)
																						; 																X1, Y1, Z1 (rechte obere Ecke)
																						; da hier keine 3D-Objekte gezeichnet werden, werden der Z-Parameter = 0 gesetzt
																						; als Startwerte können natürlich auch andere als "100" verwendet werden, oder Variable
;	
EndFunc
;
;-----------------------------------------------------------------------------------
;
Func Button2_Start()
																						; beim Betätigen des Buttons wird der Zeichenvorgang ausgelöst,
																						; d.h. es werden je nach Eingabe eine entsprechende Anzahl Linien gezeichnet
																						; Damit diese visuell unterschieden werden können, 
																						; wird automatisch der jeweilige Anfangs- und Endpunkt mit einem Versatz versehen
	Local $newLine, $inp3, $versatz
	;MsgBox (0, "Button2", $Button2)													; nur zu Testzwecken
																						; es wird der Rückgabewert der Erstellungsfunktion von Button1 ausgegeben
	$inp3 = GUICtrlRead($input3)														; Auslesen der Datenwerte 
	;MsgBox (0, "Input3", $inp3)														; nur zu Testzwecken (in $inp3 wird zwar die Eingabe als "Text" eingetragen,
																						; es erfolgt aber eine automatische Konvertierung in numerische Werte bei Verwendung)
																						; in der FOR-NEXT-Schleife
	For $versatz = 0 To $inp3
		$newLine = $activeDwg.Graphics.AddLineSingle(100 + $versatz, 100, 0, 200, 200 + $versatz, 0)
																						; hier wird die neue Linie gezeichnet mit den Koordinaten	X0, Y0, Z0 (Anfangsposition)
																						; 															X1, Y1, Z1 (Endposition)
																						; da hier keine 3D-Objekte gezeichnet werden, werden der Z-Parameter = 0 gesetzt
																						; als Startwerte können natürlich auch andere als "100" verwendet werden, oder Variable
	Next
	;
;
EndFunc